#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define str string
#define ldb long double
#define ll long long
#define db double
#define ull unsigned long long
#define ss second
#define ff first
#define pob pop_back
#define pub push_back
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
const ll INF18 = 2e18;
const int INF9 = 2e9;
const db PI = acos(-1);
const db EPS = 1e-5;
mt19937 rnd(time(0));
template <typename T, typename TT>
ostream& operator<<(ostream& out, pair<T, TT> &a) {
    out << "{" << a.ff << ' ' << a.ss << '\n';
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, vector<T> &a) {
    for (auto it : a)
        out << it << ' ';
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, set<T> &a) {
    for (auto it : a)
        out << it << ' ';
    return out;
}
#define print(...) cout << #__VA_ARGS__ << " = " << __VA_ARGS__ << '\n'
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define int ll

signed main() {
    fast
    int n;
    cin >> n;
    vector <int> a(n), c(n), dp(n, INF18), left(n, -1);
    for (auto &i : a) {
        cin >> i;
    }
    for (auto &i : c) {
        cin >> i;
    }
    vector <int> st, mn;
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[st.back()] < a[i]) {
            left[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    st.clear();
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[i] > a[st.back()]) {
            st.pop_back();
            mn.pop_back();
        }
        if (left[i] == -1) {
            dp[i] = c[i];
        } else {
            dp[i] = dp[left[i]] + c[i];
        }
        if (!st.empty()) {
            dp[i] = min(mn.back(), dp[i]);
        }
        st.push_back(i);
        int x = c[i];
        if (i) {
            x += dp[i - 1];
        }
        if (mn.empty()) {
            mn.push_back(x);
        } else {
            mn.push_back(min(mn.back(), x));
        }
    }
    cout << dp[n - 1] << '\n';
    return 0;
}
